using System;


namespace IGuitarConfig
{
    public class GuitarConfig
    {
        public int NumStrings;
        public int NumFrets;
        public String GuitarName;
        public Note[] GuitarNotes;

        public SAllFretsForNote[] AllFrets;

        public struct SAllFretsForNote
        {
            public int Gstring;
            public int Gfret;
        };

        public struct Note
        {
            public int MidiNoteNumber;
            public int GuitarString;
            public int GuitarFret;
        };

        public GuitarConfig(){
           GuitarNotes = new Note[90];

        }

        public int GetMinFret(int midinote) {
            int elementPos = GuitarNotes.Length;

            for (int i = 0; i < GuitarNotes.Length; i++) {
                if (GuitarNotes[i].MidiNoteNumber == midinote) {
                    if (i < elementPos) {
                        elementPos = i;
                    };
                };
            };
            return elementPos;
        }

        public void FillAllFretsForNote(int midinote,int maxfret = 99) {
            // count posible frets
            int fretcount = 0;
            for (int i = 0; i < GuitarNotes.Length; i++) {
                if (GuitarNotes[i].MidiNoteNumber == midinote && GuitarNotes[i].GuitarFret <= maxfret) {
                    fretcount++;
                };
            };

            AllFrets = new SAllFretsForNote[fretcount];
             fretcount = 0;
            for (int i = 0; i < GuitarNotes.Length; i++)
            {
                if (GuitarNotes[i].MidiNoteNumber == midinote && GuitarNotes[i].GuitarFret <= maxfret)
                {
                    AllFrets[fretcount].Gstring = GuitarNotes[i].GuitarString;
                    AllFrets[fretcount].Gfret = GuitarNotes[i].GuitarFret;
                    fretcount++;
                };
            };


        } //end of FillAllFretsForNote
    }
}
